#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <cstdio>

#if defined(_RTLDLL) && defined(NDEBUG)
#pragma comment (lib, "../DllRelease/pe_tls.lib")
#elif defined(_RTLDLL) && !defined(NDEBUG)
#pragma comment (lib, "../DllDebug/pe_tls.lib")
#elif !defined(_RTLDLL) && defined(NDEBUG)
#pragma comment (lib, "../Release/pe_tls.lib")
#elif !defined(_RTLDLL) && !defined(NDEBUG)
#pragma comment (lib, "../Debug/pe_tls.lib")
#endif


#pragma comment(linker, "/include:_p_thread_callback")


_declspec(thread) int _dummy;

extern "C"
{
	void on_process_enter(void)
	{
		Beep(660, 200);
		printf("on process enter\n");
		
		Sleep(200);
	}


	void on_process_exit(void)
	{
		Beep(440, 200);
		printf("on process exit\n");
		
		Sleep(200);
	}


	void on_thread_exit(void)
	{
		Beep(880, 200);
		printf("on thread exit\n");

		Sleep(200);
	}
}


DWORD WINAPI f(void *)
{
	Sleep(400);
	return 0;
}


int main(int argc, char* argv[])
{
	printf("entering main\n");

	DWORD id;
	HANDLE h = CreateThread(NULL, 0, &f, 0, 0, &id);
	WaitForSingleObject(h, INFINITE);
	CloseHandle(h);

	_dummy = 0;

	printf("leaving main\n");

	return _dummy;
}

